{----------------------------------------------------------------}
{ ALPHA FORM - Sub0 - Developpez.com - 09/06/06                  }
{----------------------------------------------------------------}
{$X+}
Unit Unit1;
Interface
Uses Windows, Messages, SysUtils, Classes, Graphics, Controls,
     Forms, Dialogs, ExtCtrls, StdCtrls, Math, HSLUtils;

CONST
  PixelCountMax = 32768;

TYPE
  pRGBTripleArray = ^TRGBTripleArray;
  TRGBTripleArray = ARRAY[0..PixelCountMax-1] OF TRGBTriple;

  TForm1 = Class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
  private
    procedure WMNCHitTest(var M: TWMNCHitTest); message wm_NCHitTest;
    procedure Redraw;
  End;

Var
  Form1: TForm1;

implementation
{$R *.DFM}

Var InitialBitmap,FinalBitmap: TBitmap;

procedure TForm1.Button1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FinalBitmap.Free;
  InitialBitmap.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DoubleBuffered:=true;
  FinalBitmap:=TBitmap.Create;
  InitialBitmap:=TBitmap.Create;
  InitialBitmap.LoadFromFile('form2.bmp');
  FinalBitmap.LoadFromFile('form2.bmp');
  width:=FinalBitmap.Width;
  height:=FinalBitmap.Height;
  Redraw;
end;

procedure TForm1.FormPaint(Sender: TObject);
VAR i,j,Py  :  INTEGER;
    Row:  pRGBTripleArray;
    AColorRef,BmpColor,ATransparentColor:Cardinal;
    HTransparent,H,S,L,HRef,SRef,LRef:integer;
    APoint:TPoint;
    aDC:HDC;
    Opacity,R,G,B:byte;
begin
  Redraw;
  Canvas.Draw(0,0,FinalBitmap);
end;

//dplacement de la fiche
procedure TForm1.WMNCHitTest(var M: TWMNCHitTest);
begin
  inherited;
  if  M.Result = htClient then  { le clic est sur la zone cliente ?   }
    M.Result := htCaption;      { Oui--> on fait croire  Windows     }
                                { qu'il a eu lieu sur la barre des titres. }
  Repaint;
end;

procedure TForm1.Redraw;
  VAR i,j,Py  :  INTEGER;
    RowI,RowF:  pRGBTripleArray;
    AColorRef,BmpColor,ATransparentColor:Cardinal;
    HTransparent,H,S,L,HRef,SRef,LRef:integer;
    APoint:TPoint;
    aDC:HDC;
    Opacity,R,G,B:byte;
begin
  if FinalBitmap.Canvas.LockCount>0 then exit;
  FinalBitmap.Canvas.Lock;
  FinalBitmap.Canvas.Unlock;

  aDC:=GetDC(0);
  RGBtoHSLRange(clFuchsia,HTransparent,S,L);
  ATransparentColor:=ColorToRGB(clFuchsia);
  APoint:=ClientToScreen(Point(0,0));
  FOR j := 0 TO FinalBitmap.Height-1 DO
  BEGIN
    Py:=APoint.Y+j;
    RowI := InitialBitmap.Scanline[j];
    RowF := FinalBitmap.Scanline[j];
    FOR i := 0 TO FinalBitmap.Width-1 DO
    BEGIN
      WITH RowI[i] DO
      BEGIN
        BmpColor:=SetRGB(rgbtRed,rgbtGreen,rgbtBlue);
        RGBtoHSLRange(BmpColor,H,S,L);

        if HTransparent=H
        then begin
               AColorRef:=GetPixel(aDC,APoint.X+i,Py);
               Opacity:=rgbtRed;
               R:=GetRValue(AColorRef);
               G:=GetGValue(AColorRef);
               B:=GetBValue(AColorRef);
               R:=(R + Opacity) div 2;
               G:=(G + Opacity) div 2;
               B:=(B + Opacity) div 2;
               RowF[i].rgbtBlue:=B;
               RowF[i].rgbtGreen:=G;
               RowF[i].rgbtRed:=R;
               SetPixel(Canvas.Handle,i,j,RGB(R,G,B));
             end;
      END
    END
  END;
  ReleaseDC(0,aDC);
end;

procedure TForm1.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  Repaint;
end;

End.



